<?php

namespace jrosset\CliProgram\AutoDiscovery;

use jrosset\Collections\Collection;
use jrosset\Collections\ICollection;

/**
 * An application with command auto discovery
 */
trait TAutoDiscoveryApplication {
    /**
     * @var ICollection<IAutoDiscoverySpot> The list of discovery spots
     */
    private ICollection $autoDiscoverySpots;

    /**
     * The list of discovery spots
     *
     * @return ICollection<IAutoDiscoverySpot> The list of discovery spots
     */
    public function getAutoDiscoverySpots (): ICollection {
        if (!isset($this->autoDiscoverySpots)) {
            $this->autoDiscoverySpots = new Collection();
        }
        return $this->autoDiscoverySpots;
    }

    /**
     * Add discovered commands to application
     *
     * @return $this
     */
    public function addAutoDiscoveredCommands (): self {
        foreach ($this->getAutoDiscoverySpots() as $autoDiscoverySpot) {
            foreach ($autoDiscoverySpot->getCommands() as $command) {
                $this->add($command);
            }
        }
        return $this;
    }
}